package com.biganto.visual.roompark.data.repository.db

import com.biganto.visual.roompark.data.repository.db.requrey.model.FeedEntity
import com.biganto.visual.roompark.data.repository.db.requrey.model.UserEntity
import io.reactivex.Observable
import io.reactivex.Single
import io.requery.Persistable

/**
 * Created by Vladislav Bogdashkin on 29.10.2019.
 */
interface IDb {
    fun upsertUser(entity: UserEntity): Observable<UserEntity>?
    fun <T : Persistable> upsert(entity: T): Single<T>
    fun <T : List<Persistable>> upsert(entity: T): Single<Iterable<Persistable>>
    fun fetchFeeds(): Observable<FeedEntity>
    fun fetchUser(uuid: Int): Observable<UserEntity>
    fun <T : List<Persistable>> blockingUpsert(entity: T)
}