package com.biganto.visual.roompark.data.repository.mapper

import android.content.res.Resources
import com.biganto.visual.roompark.data.repository.api.retrofit.raw.AuthRaw
import com.biganto.visual.roompark.data.repository.api.retrofit.raw.FeedRaw
import com.biganto.visual.roompark.data.repository.db.requrey.model.FeedEntity
import com.biganto.visual.roompark.data.repository.db.requrey.model.UserEntity
import kotlin.math.max

/**
 * Created by Vladislav Bogdashkin on 06.11.2019.
 */

private val display = Resources.getSystem().displayMetrics

fun fromRaw(raw: AuthRaw) : UserEntity {
    val user = UserEntity()
    user.setEmail(raw.email)
    user.setUuid(raw.id)
    user.setAuthToken(raw.token)
    user.setName(raw.name)
    user.setTargetResolution(calcTargetResolution)
    return user
}

fun fromRaw(raw:FeedRaw) : FeedEntity {
    val entity  = FeedEntity()
    entity.setId(raw.id)
    entity.setTitle(raw.title)
    entity.setAlias(raw.alias)
    return entity
}

fun fromRaw(raw: List<FeedRaw>):List<FeedEntity> = List(raw.size) { index-> fromRaw(raw[index]) }



val calcTargetResolution = max(display.widthPixels,display.heightPixels)
