package com.biganto.visual.roompark.domain.model

import com.biganto.visual.roompark.data.repository.db.requrey.model.FeedEntity
import java.util.*

/**
 * Created by Vladislav Bogdashkin on 23.09.2019.
 */


data class FeedModel(val feedId:Int, val title:String, val alias:String? = null)

data class FeedsHeaderModel(val feeds:List<FeedModel>)

data class ArticlePreviewModel(
    val articleId:Int,
    val published: Date,
    val title:String,
    val announce:String,
    val previewUrl:String,
    val isRead:Boolean
    )

data class ArticlesPreviewModel(val parentFeedId:Int,val articles:List<ArticlePreviewModel>)


data class ArticleModel(
    val articleId:Int,
    val published: Date,
    val title:String,
    val htmlBody:String,
    val previewUrl:String,
    val isRead:Boolean
)

fun fromEntity(entity: FeedEntity):FeedModel = FeedModel(
    feedId = entity.id,
    title = entity.title,
    alias = entity.alias
)

fun <E,M> fromEntity(raw: List<E>,block:(E)->M):List<M> = List(raw.size) { index-> block(raw[index]) }
